
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Red

extern string s_1 = "Settings";
extern bool Super_Powerful_Signal_Only = TRUE;
extern bool Alert_Message = TRUE;
extern bool Alert_Email = FALSE;
double g_period_96 = 50.0;
double gd_104 = 0.7;
double gd_112 = 0.3;
bool gi_unused_120 = TRUE;
double g_ibuf_124[];
double g_ibuf_128[];
double g_ibuf_132[];

int init() {
   if (ObjectType("lbl") != 23) ObjectDelete("lbl");
   if (ObjectFind("lbl") == -1) ObjectCreate("lbl", OBJ_LABEL, 0, Time[5], Close[5]);
   ObjectSetText("lbl", "SuperGain Indicator (C)");
   ObjectSet("lbl", OBJPROP_FONTSIZE, 9);
   ObjectSet("lbl", OBJPROP_XDISTANCE, 5);
   ObjectSet("lbl", OBJPROP_YDISTANCE, 20);
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, g_ibuf_124);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, g_ibuf_128);
   SetIndexEmptyValue(1, 0.0);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, g_ibuf_132);
   SetIndexEmptyValue(2, 0.0);
   return (0);
}

int deinit() {
   ObjectDelete("lbl");
   return (0);
}

int start() {
   double lda_8[3];
   double lda_12[3];
   double l_istochastic_16;
   if (ObjectType("lbl") != 23) ObjectDelete("lbl");
   if (ObjectFind("lbl") == -1) ObjectCreate("lbl", OBJ_LABEL, 0, Time[5], Close[5]);
   ObjectSetText("lbl", "SuperGain Indicator (C)");
   ObjectSet("lbl", OBJPROP_FONTSIZE, 9);
   ObjectSet("lbl", OBJPROP_XDISTANCE, 5);
   ObjectSet("lbl", OBJPROP_YDISTANCE, 20);
   double l_iatr_0 = iATR(Symbol(), 0, 50, 1);
   for (int l_shift_24 = 0; l_shift_24 < Bars; l_shift_24++) g_ibuf_132[l_shift_24] = 0.0;
   for (l_shift_24 = 0; l_shift_24 < Bars; l_shift_24++) {
      g_ibuf_124[l_shift_24] = 0.0;
      g_ibuf_128[l_shift_24] = 0.0;
      l_istochastic_16 = iStochastic(Symbol(), 0, 80, 10, 10, MODE_SMA, 0, MODE_MAIN, l_shift_24);
      for (int l_index_28 = 0; l_index_28 < 3; l_index_28++) {
         lda_8[l_index_28] = iDeMarker(Symbol(), 0, g_period_96, l_shift_24 + l_index_28);
         lda_12[l_index_28] = iRSI(Symbol(), 0, 20, PRICE_CLOSE, l_shift_24 + l_index_28);
      }
      if ((lda_8[0] > gd_112 && lda_8[1] < gd_112) && (lda_12[0] < 30.0 || lda_12[1] < 30.0 || lda_12[2] < 30.0 || (!Super_Powerful_Signal_Only))) {
         g_ibuf_124[l_shift_24] = Low[l_shift_24] - l_iatr_0 / 2.0;
         g_ibuf_132[l_shift_24] = Low[iLowest(Symbol(), 0, MODE_LOW, 4, l_shift_24)] - l_iatr_0 / 2.0;
         g_ibuf_132[l_shift_24 + 1] = g_ibuf_132[l_shift_24];
         g_ibuf_132[l_shift_24 - 1] = g_ibuf_132[l_shift_24];
      }
      if ((lda_8[0] < gd_104 && lda_8[1] > gd_104) && (lda_12[0] > 70.0 || lda_12[1] > 70.0 || lda_12[2] > 70.0 || (!Super_Powerful_Signal_Only))) {
         g_ibuf_128[l_shift_24] = High[l_shift_24] + l_iatr_0 / 2.0;
         g_ibuf_132[l_shift_24] = High[iHighest(Symbol(), 0, MODE_HIGH, 4, l_shift_24)] + l_iatr_0 / 2.0;
         g_ibuf_132[l_shift_24 + 1] = g_ibuf_132[l_shift_24];
         g_ibuf_132[l_shift_24 - 1] = g_ibuf_132[l_shift_24];
      }
   }
   if (g_ibuf_124[2] == 0.0 && g_ibuf_124[1] != 0.0 && Open[0] == Low[0] && Open[0] == High[0] && Open[0] == Close[0]) {
      if (Alert_Message) Alert("SuperGain Indicator: Long Trade at " + Symbol() + ", Stop Loss at " + g_ibuf_132[0]);
      if (Alert_Email) SendMail("SuperGain Indicator: Long Trade", "SuperGain Indicator: Long Trade at " + Symbol() + ", Stop Loss at " + g_ibuf_132[0]);
   }
   if (g_ibuf_128[2] == 0.0 && g_ibuf_128[1] != 0.0 && Open[0] == Low[0] && Open[0] == High[0] && Open[0] == Close[0]) {
      if (Alert_Message) Alert("SuperGain Indicator: Short Trade at " + Symbol() + ", Stop Loss at " + g_ibuf_132[0]);
      if (Alert_Email) SendMail("SuperGain Indicator: Short Trade", "SuperGain Indicator: Short Trade at " + Symbol() + ", Stop Loss at " + g_ibuf_132[0]);
   }
   return (0);
}